

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <errno.h>
#include <ctype.h>
#include <stddef.h>

#include "words.h"
#include "rooms.h"
#include "player.h"

//#include a system's specific version of my SimpleIO library.
#ifdef __CBM__
#include "simpleio.h"
#elif defined __ATARI__
#include "atasimpleio.h"
#include "atadisk65.h"
#endif

#ifdef __NOCOMPTEXT__
//If not compressing text, redirect calls to printtok() which prints compressed text to
//prints() from the *SImpleIO libraries which doesn't..
#define printtok prints
#else
void __fastcall__ printtok (char* str);
#endif

//For 32k (large) cartridges, #include a header file containing function declarations that
//handle access to the extra memory.
#ifdef __DOFE3__
#include "c64cart_fe3\final3cart.H"
#endif

//All the player's information.
struct player_ Player;

//Current room #
extern unsigned char CRoom;
#pragma zpsym ("CRoom")

//Temp variables
extern unsigned char i, j;
#pragma zpsym ("i")
#pragma zpsym ("j")

//Current verb #
extern unsigned char Vrb;
#pragma zpsym ("Vrb")

//Temp: current pos. in text scanning.
extern unsigned char CurPos;
#pragma zpsym ("CurPos")

//More temp variables
extern unsigned char c;
#pragma zpsym ("c")

//Temp. pointer to string for string-processing
extern unsigned char* s;
#pragma zpsym ("s")

//Pointer to current room in room database
extern struct room* CRm;
#pragma zpsym ("CRm")

//Look verb entry declaration for no item specified
void vLook2 (void);

//Declaration for function that prints a period followed by a return.
void __fastcall__ printperiod (void);

//Line of input from user.
char Input [21];

//Functions that load the program's extra stubs into memory
//if not on a cartridge.
#ifdef __CBM__

void cbm_open2 (unsigned char);

#if !defined __DOCART__  && defined __CBM__
#ifndef __PET__
//CBM entry for computers other than the PET.
//First stub filename: the number will be incremented after load.
static char fi[]="stub1";

static void __fastcall__ load2 (void)
{
	__asm__ (
		"\tlda\t#0\n"
		"\tldx\t#8\n"
		"\tldy\t#1\n"
		"\tjsr\tSETLFS\n"
		"\tlda\t#5\n"
		"\tldx\t#<_fi\n"
		"\tldy\t#>_fi\n"
		"\tjsr\tSETNAM\n"
		"\tlda\t#0\n"
		"\ttax\n"
		"\ttay\n"
		"\tjsr\tLOAD\n"
		);
	++fi[4];
}

//Entry for the PET, as it requires extra work to load from disk.
#elif defined __CBM__
static void __fastcall__ load2 (char* s, unsigned char nsize)
{
	__asm__ (
		"\tjsr\tpopa\n"
		"\tsta\ttmp1\n"
		"\tjsr\tpopax\n"
		"\tsta\tptr1\n"
		"\tstx\tptr1+1\n"

		"\tlda\t#1\n"
		"\tldx\t#8\n"
		"\tldy\t#0\n"
		"\tjsr\tSETLFS\n"
		"\tlda\ttmp1\n"
		"\tldx\tptr1\n"
		"\tldy\tptr1+1\n"
		"\tjsr\tSETNAM\n"
		"\tjsr\tOPEN\n"
		"\tldx\t#1\n"
		"\tjsr\tCHKIN\n"
		"\tjsr\tBASIN\n"
		"\tsta\tptr2\n"
		"\tjsr\tBASIN\n"
		"\tsta\tptr2+1\n"
		"@a01:\n"
		"\tjsr\tBASIN\n"
		"\tldy\t#0\n"
		"\tsta\t(ptr2),y\n"
		"\tinc\tptr2\n"
		"\tbne\t@a02\n"
		"\tinc\tptr2+1\n"
		"@a02:\n"
		"\tjsr\tREADST\n"
		"\tcmp\t#0\n"
		"\tbeq\t@a01\n"
		"\tjsr\tCLRCH\n"
		"\tlda\t#1\n"
		"\tjmp\tCLOSE\n"
		);
}
#endif

#endif

#ifdef __VIC20__
#pragma code-name (push, "BUF1C")
#endif

#ifdef __PET__
#pragma code-name (push, "TAPECODE")
#endif

#if defined __C16__ && !defined __DOCART__
#pragma code-name (push, "INPUTCO")
#endif

//Function to load a saved game whose name is given in c.
void loadgame (char* c)
{
	s=c;
	//cbm_open (1, 8, CBM_READ, c);
	cbm_open2 (CBM_READ);
	cbm_read (1, &Player, sizeof (Player));
	cbm_close (1);
}

#if defined __C64__ && !defined __DOCART__
#pragma code-name (push, "BASINCODE")
#endif

#if defined __C16__ && !defined __DOCART__
#pragma code-name (pop)
#endif

#ifdef __VIC20__
#pragma code-name ("BUF4C")
#endif

#ifdef __PET__
#pragma code-name (push, "DOSCODE")
#endif

#if defined __C16__ && !defined __DOCART__
#pragma code-name (push, "TAPECO")
#endif

//Function to save a game whose name is given in c.
void savegame (char* c)
{
	s=c;
	//cbm_open (1, 8, CBM_WRITE, c);
	cbm_open2 (CBM_WRITE);
	cbm_write (1, &Player, sizeof (Player));
	cbm_close (1);
}
#if !defined __C64__ && !defined __DOCART__
#pragma code-name (pop)
#endif
#endif



#ifdef __VIC20__
#pragma code-name (push, "BUF1C")
#endif

#if defined __C64__ && !defined __DOCART__
#pragma code-name (push, "TAPECODE")
#endif

#if defined __ATARI__ && !defined __DOCART__
#pragma code-name (push, "MBUFCODE")
#endif

//After parsing the verb, this function skips the space if found.
void eatspaces (void)
{
	__asm__ (
		"\tldx\t_CurPos\n"
		"\tlda\t_Input,x\n"
		"\tcmp\t#32\n"
		"\tbne\t@a01\n"
		"\tinc\t_CurPos\n"
		"@a01:\n"
		);
}

//ClearPlayerInv() initializes the player's inventory by emptying it out.
//It is put in a separste function so to use my Cubbyhole optimization
//technique.
#if defined __VIC20__
#pragma code-name ("BUF2C")
void ClearPlayerInv (void)
{
	__asm__ (
		"\tlda\t#255\n"
		"\tldx\t#7\n"
		"@a01:\n"
		"\tsta\t%v+%w,x\n"
		"\tdex\n"
		"\tbpl\t@a01\n",
		Player, offsetof (struct player_, Inv)
		);

}
#elif defined __C64__
#ifndef __DOCART__
#pragma code-name (pop)
#endif
void ClearPlayerInv (void)
{
	__asm__ (
		"\tlda\t#255\n"
		"\tldx\t#7\n"
		"@a01:\n"
		"\tsta\t%v+%w,x\n"
		"\tdex\n"
		"\tbpl\t@a01\n",
		Player, offsetof (struct player_, Inv)
		);

}
//#pragma code-name (pop)
#endif

#if defined __C64__ && !defined __DOCART__
#pragma code-name (pop)
#endif

#ifdef __ATARI__
#pragma code-name (push, "MBUFCODE")
void ClearPlayerInv (void)
{
	__asm__ (
		"\tlda\t#255\n"
		"\tldx\t#7\n"
		"@a01:\n"
		"\tsta\t%v+%w,x\n"
		"\tdex\n"
		"\tbpl\t@a01\n",
		Player, offsetof (struct player_, Inv)
		);

}
#pragma code-name (pop)
#endif
#if defined __C16__ && !defined __DOCART__
#pragma code-name (push, "BSTKCO")
#endif

#if defined __C64__ && !defined __DOCART__
#pragma code-name (push, "BASINCODE")
#endif

//Second part of the program init. routine, to be stored in a stub.
void InitPlayer2 (void)
{
#if !defined __C16__ && !defined __VIC20__
	//Fill the player's inventory w/ -1's to indicate that it's empty.
	__asm__ (
		"\tlda\t#255\n"
		"\tldx\t#7\n"
		"@a01:\n"
		"\tsta\t%v+%w,x\n"
		"\tdex\n"
		"\tbpl\t@a01\n",
		Player, offsetof (struct player_, Inv)
		);
#endif
	//Copy the default room inventories to the player's information.
	memcpy (&Player.RoomInv, &DefRoomItems, (NumRooms<<3));
#if defined __PET__ || defined __VIC20__
	CRoom=0;
#endif
}

#if defined __ATARI__ && !defined __DOCART__
#pragma code-name (pop)
#endif

#if !defined __C64__ && !defined __ATARI__ && !defined __DOCART__
#pragma code-name (pop)
#endif

#if defined __C64__ && !defined __DOCART__
#pragma code-name (pop)
#endif

//First part of the program init. routine: loads the stubs and
//perform other tasks depending on system.
//The latter is because not everything fits in a stub on most computers.
void InitPlayer (void)
{
//If not on a cartridge,  load stubs.
//Otherwise, there are no stubs to load.
#ifndef __DOCART__
#ifdef __ATARI__
	prints ("Loading data...");
	cio_load (1, "D1:MEMX1.BIN", 0x15A4, 0x0442);
//printc ('.'); getkey();
#elif defined __PET__
//The PET version specifies the filename to load, followed by the len.
//The len. is to skip a call to strlen().  I really need to
//do the same thing as the other CBM targets and imply the name and just
//increment the #.
	prints ("Loading data...");
	load2 ("tape", 4);
	load2 ("input", 5);
	load2 ("dosstr", 6);
	load2 ("zp2", 3);
#else
//Other targets use the filename "stub1" and increments the # after every load.
	prints ("Loading data...");
	load2 ();
	load2 ();
	load2 ();
	load2 ();
#endif
	printscr ("Done!");
#endif
//If not a PET, set the room # to the first room.
//On a PET, InitPlayer2() sets the room #.
#if !defined __PET__ && !defined __VIC20__
	CRoom=0;
#endif
//On a C16, clear the player's inventory by writing -1's which indicate no item.
//On other systems, InitPlayer2() does the job.
#ifdef __C16__
	__asm__ (
		"\tlda\t#255\n"
		"\tldx\t#7\n"
		"@a01:\n"
		"\tsta\t%v+%w,x\n"
		"\tdex\n"
		"\tbpl\t@a01\n",
		Player, offsetof (struct player_, Inv)
		);
#else
	ClearPlayerInv ();
#endif
	//Call second init. function.
	InitPlayer2 ();
}

#ifdef __VIC20__
#pragma code-name (push, "BUF3C")
#elif defined __C16__ && !defined __DOCART__
#pragma code-name ("TAPECO")
#elif defined __PET__
#pragma code-name (push, "ZP2CODE")
#endif

//Line input routine for different targets.
#ifdef __ATARI__
#if defined __ATARI__ && !defined __DOCART__
#pragma code-name (push, "MBUFCODE")
#endif

unsigned char __fastcall__ GetInput (void)
{
	//Start with empty line.
	CurPos=0;
	//CurPos=In;
	//Prompt.  If you desire a different prompt, print it
	//here.
	printc ('>');
	//Main loop:
	while (1)
	{
		//Enable cursor and get key.
		c = getkey ();

		//Process the key.
		if (c=='\n'){ /*return*/
			Input[CurPos]=0;		//Terminate input string.
			printcr ();		//Go to next screen line.
			//CurPos=CurPos;
			return CurPos;			//Return string len.
		} if (c == CH_DEL && CurPos) { /* delete */
			//Won't be processed if the buffer is empty.
			--CurPos;		//Cursor left.
			printc (CH_DEL);		//Delete last char. from screen.
		} if ((isprint(c)) && CurPos<20) { //Printable char.
			printc (Input[CurPos]=c);	//Add key to buffer and advance.
			++CurPos;
		}
	}
}

#if defined __ATARI__ && !defined __DOCART__
#pragma code-name (pop)
#endif

#else
unsigned char __fastcall__ GetInput (void)
{
	CurPos=0;
	printc ('>');
	while (1)
	{
		//Display simulated cursor and get key from user.
		printc ('_');
		i = getkey ();
		//Delete the simulated key press.
		printc (20);
		//Process input key.
		if (i==13){ /*return*/
			Input[CurPos]=0;		//End string,
			printcr ();			//print Return
			return CurPos;			//and exit w/ len' of input withput the NUL.
		} if (i == 20 && CurPos) { /* delete */
			--CurPos;
			printc (20);
		}
		//Printable character.
		if ((i&0x60) && CurPos<20) {
			//Print char and advence pos.
			printc (Input[CurPos]=i);
			++CurPos;
		}
	}
}
#endif

#ifdef __VIC20__
#pragma code-name (pop)
#elif defined __C16__
#pragma code-name ("CODE")
#elif defined __PET__
#pragma code-name (pop)
#endif


void main (void)
{
	//Holds the function pointer to the current verb's handling
	//code.
	static void (* vfunc) (void);
	//Init. and display start-up text.
#ifdef __C64__
	backcol=1; brdrcol=3;
#endif
	printscr("\f\n\x9cPlace intro here.\n\n"

		 "Type INTRO during the game for\n"
		 "instructions.\n\n"
		 "Do you want to load a saved game?");
	c=0;
	switch (getkey ())
	{
	//Enable the following line if you want to be able to jump to any room
	//at start-up by pressing D here.
	//case 'd': ++c;
	case 'y': ++c;
	}
	InitPlayer ();
	//Enable the following lines if you want to be able to jump to any room
	//at start-up.
	// if (c==2) {
		// printscr ("Debug mode: Enter room #"); GetInput (4);
		// //CRoom=0;
		// for (CurPos=0;Input[CurPos]; ++CurPos)
		// {
			// //CRoom=CRoom*10+(Input[CurPos]-'0');
			// //CRoom=CRoom*10+(Input[CurPos]&0xF);
			// CRoom=(((CRoom<<2)+CRoom)<<1)+(Input[CurPos]&0xF);
		// }
		// //CRoom=atoi(Input);
	// }
	//If c==1, load game here.  You can use the loadgame() function
	//defined above.
	
	//Display room info using look without item.
	vLook2 ();
	while (1)
	{
		//Get command from user and, if none loop.
		if (!GetInput ()) continue;
		//Get verb #.
		Vrb = FindVerb ();
		//If not found, error.
		if (Vrb==0xFF) {
			prints ("I don't know how to ");
			prints (Input); 
			printperiod ();
			continue;
		}
		//Skip spaces in the input between verb and noun.
		eatspaces ();
		//Clear item #.  (-1 indicates no item.)
		Itm1=-1;
		s=&Input[CurPos];
		if (*s)
		{
			if ((Itm1 = FindItem ())==255) {
				prints ("I don't know what a ");
				prints (s);
				printscr (" is.");
				continue;
			}
		}
		//Get address of verb-handler and execute it.
#ifdef __DOFE3__
		//32k cartridges need extra work to access the address, as it is
		//stored in a location not directly accessible to the code.
		vfunc=bankgetword((void*)&Verb[Vrb].vdo);
		(*vfunc) ();
#else
		(*Verb[Vrb].vdo) ();
#endif
	}
}

