;
; Startup code for cc65 (C64 version)
;

	;.export		_exit
        .export         __STARTUP__ : absolute = 1      ; Mark as startup
	.import		initlib, donelib, callirq
       	.import	       	zerobss
	.import	     	callmain, pushax
        .import         RESTOR, BSOUT, CLRCH
	.import	       	__INTERRUPTOR_COUNT__
	.import		__RAM_START__, __RAM_SIZE__	; Linker generated

        .exportzp	_i, _j, _Itm1, _CRoom, _CurPos, _CurItem, _s, _Vrb, _c
        .exportzp	_CRm, _CurRoomInv, _e, _ItemPtr, _s2

	.import		_getkey, _puts, _memcpy, _main

	.export		_printmsg

        .import         _printc, _printcr, _prints, _printtok, _Message, _printscr

	.import		__LOWCODE_LOAD__, __LOWCODE_RUN__, __LOWCODE_SIZE__
	.import		__CODE_LOAD__, __CODE_RUN__, __CODE_SIZE__
	.import		__RODATA_LOAD__, __RODATA_RUN__, __RODATA_SIZE__
	.import		__DATA_LOAD__, __DATA_RUN__, __DATA_SIZE__
	.import		__BANKACCESS_LOAD__, __BANKACCESS_RUN__, __BANKACCESS_SIZE__

        .include        "zeropage.inc"
	.include     	"c64.inc"


.segment	"STARTUP"
	.word	startup		;Cold start
	.word	$FEBC		;Warm start, default calls NMI exit.
	.byt	$C3,$C2,$CD,$38,$30 ;magic to identify cartridge

startup:
	jsr	$FF84		;Init. I/O
	jsr	$FF87		;Init. RAM
	jsr	$FF8A		;Restore vectors
	jsr	$FF81		;Init. screen
	
; Switch to second charset
	lda	#14
	jsr	BSOUT

; Clear the BSS data

; If we have IRQ functions, chain our stub into the IRQ vector

;        lda     #<__INTERRUPTOR_COUNT__
;      	beq	NoIRQ1
;      	lda	IRQVec
;       	ldx	IRQVec+1
;      	sta	IRQInd+1
;      	stx	IRQInd+2
;      	lda	#<IRQStub
;      	ldx	#>IRQStub
;      	sei
;      	sta	IRQVec
;      	stx	IRQVec+1
;      	cli

; Call module constructors

	
NoIRQ1:
	jsr	zerobss

	;lda    	#<(__RAM_START__ + __RAM_SIZE__)
	;sta	sp
	;lda	#>(__RAM_START__ + __RAM_SIZE__)
       	;sta	sp+1   		; Set argument stack ptr
	lda	#$00
	sta	sp
	lda	#$D0
	sta	sp+1

;	lda	#<__BANKACCESS_LOAD__
;	ldx	#>__BANKACCESS_LOAD__
;	jsr	pushax
;	lda	#<__BANKACCESS_RUN__
;	ldx	#>__BANKACCESS_RUN__
;	jsr	pushax
;	lda	#<__BANKACCESS_SIZE__
;	ldx	#>__BANKACCESS_SIZE__
;	jsr	_memcpy

	lda	#<__DATA_LOAD__
	sta	ptr1
	lda	#>__DATA_LOAD__
	sta	ptr1+1

	lda	#<__DATA_RUN__
	sta	ptr2
	lda	#>__DATA_RUN__
	sta	ptr2+1

	lda	#<__DATA_SIZE__
	sta	ptr3
	lda	#>__DATA_SIZE__
	sta	ptr3+1
	jsr	copym

;	lda	#<__DATA_LOAD__
;	ldx	#>__DATA_LOAD__
;	jsr	pushax
;	lda	#<__DATA_RUN__
;	ldx	#>__DATA_RUN__
;	jsr	pushax
;	lda	#<__DATA_SIZE__
;	ldx	#>__DATA_SIZE__
;	jsr	_memcpy

	lda	#<__BANKACCESS_LOAD__
	sta	ptr1
	lda	#>__BANKACCESS_LOAD__
	sta	ptr1+1

	lda	#<__BANKACCESS_RUN__
	sta	ptr2
	lda	#>__BANKACCESS_RUN__
	sta	ptr2+1

	lda	#<__BANKACCESS_SIZE__
	sta	ptr3
	lda	#>__BANKACCESS_SIZE__
	sta	ptr3+1
	jsr	copym

	jsr	initlib


start2:

	;lda	#0
	;jmp	_bankrun
	jsr	_main
	jsr	donelib
	jmp	startup

copym:
	lda	ptr3
	ora	ptr3+1
	bne	*+3
	rts
	ldy	#0
@lp:
	lda	(ptr1),y
	sta	(ptr2),y
	inc	$D020
	inc	ptr1
	bne	*+4
	inc	ptr1+1
	inc	ptr2
	bne	*+4
	inc	ptr2+1
	lda	ptr3
	bne	*+4
	dec	ptr3+1
	dec	ptr3
	lda	ptr3
	ora	ptr3+1
	bne	@lp
	rts
	
;m:
;	.byt	"Hello, world!\n",0
.segment	"LOWCODE"
.segment	"CODE4"
.segment	"RODATA4"

.zeropage
_i:		.res	1
_j:		.res	1
_Itm1:		.res	1
_CRoom:		.res	1
_CurPos:	.res	1
_CurItem:	.res	1
_s:		.res	2
_Vrb:		.res	1
_c:		.res	1
_CRm:		.res	2
_CurRoomInv:	.res	2
_e:		.res	1
_ItemPtr:	.res	2
_s2:		.res	2

.code
_printmsg:
	asl
	tax
	lda	_Message,x
	pha
	lda	_Message+1,x
	tax
	pla
	;jsr	_printtok
	jmp	_printscr
